import {
  Get,
  Post,
  Body,
  Put,
  Param,
  Query,
  Delete,
  Inject,
  Controller,
} from '@nestjs/common';
import {
  ApiTags,
  ApiOperation,
  ApiBearerAuth,
  ApiExtraModels,
  ApiOkResponse,
  ApiCreatedResponse,
} from '@nestjs/swagger';

import { ApiGenericResponse } from '@api-c3/swagger';
import { JsonResponse } from '@api-c3/json-response';
import { QueryParamsDto } from '@api-c3/query-parser';

import { {{EntityName}} } from './entity/{{dashLowerCase EntityName}}.entity';
import { Create{{EntityName}}Dto } from './dto/create-{{dashLowerCase EntityName}}.dto';
import { Update{{EntityName}}Dto } from './dto/update-{{dashLowerCase EntityName}}.dto';

import { {{EntityName}}Service } from './{{dashLowerCase EntityName}}.service';

@ApiTags('{{sentenceAndPluralCase EntityName}}')
@Controller('{{dashAndPluralLowerCase EntityName}}')
@ApiExtraModels(JsonResponse, {{EntityName}})
export class {{EntityName}}Controller {
  @Inject()
  private readonly {{camelCase EntityName}}Service: {{EntityName}}Service;

  @ApiBearerAuth()
  @ApiOperation({
    summary: 'Create',
    description: 'Create a new {{EntityName}}',
  })
  @ApiGenericResponse(JsonResponse, {{EntityName}}, ApiCreatedResponse)
  @Post()
  public async create(@Body() createDto: Create{{EntityName}}Dto): Promise<{{EntityName}}> {
    return await this.{{camelCase EntityName}}Service.create(createDto);
  }

  @ApiBearerAuth()
  @ApiOperation({
    summary: 'Get All',
    description: 'Gets all {{sentenceAndPluralCase EntityName}}',
  })
  @ApiGenericResponse(JsonResponse, {{EntityName}}, ApiOkResponse)
  @Get()
    public async findAll(
    @Query() query: QueryParamsDto,
  ): Promise<{
    data: {{EntityName}}[];
    count: number;
    query: QueryParamsDto;
  }> {
    const [data, count] = await Promise.all([
      this.{{camelCase EntityName}}Service.findAll(query),
      this.{{camelCase EntityName}}Service.count(),
    ]);

    return {
      data,
      count,
      query,
    };
  }

  @ApiBearerAuth()
  @ApiOperation({
    summary: 'Get by ID',
    description: 'Get a {{EntityName}} by ID',
  })
  @ApiGenericResponse(JsonResponse, {{EntityName}}, ApiOkResponse)
  @Get(':id')
  public async findOne(@Param('id') id: string): Promise<{{EntityName}}> {
    return await this.{{camelCase EntityName}}Service.findOne(id);
  }

  @ApiBearerAuth()
  @ApiOperation({
    summary: 'Update by ID',
    description: 'Update a {{EntityName}} by ID',
  })
  @ApiGenericResponse(JsonResponse, {{EntityName}}, ApiOkResponse)
  @Put(':id')
  public async update(
    @Param('id') id: string,
    @Body() updateDto: Update{{EntityName}}Dto,
  ): Promise<{{EntityName}}> {
    return await this.{{camelCase EntityName}}Service.update(id, updateDto);
  }

  @ApiBearerAuth()
  @ApiOperation({
    summary: 'Delete by ID',
    description: 'Delete a {{EntityName}} by ID',
  })
  @ApiGenericResponse(JsonResponse, {{EntityName}}, ApiOkResponse)
  @Delete(':id')
  public async delete(@Param('id') id: string): Promise<{{EntityName}}> {
    return await this.{{camelCase EntityName}}Service.delete(id);
  }
}
